SystemOrganization addCategory: #'Pier-Media'!

PRExternalLink subclass: #PRSlideShareLink
	instanceVariableNames: 'data'
	classVariableNames: 'ApiKey SharedSecret'
	poolDictionaries: ''
	category: 'Pier-Media'!

!PRSlideShareLink class methodsFor: 'initialization' stamp: 'lr 9/8/2008 21:44'!
initialize
	ApiKey := MACompatibility
		request: 'SlideShare API Key:'
		default: '(get from http://www.slideshare.net/developers/applyforapi)'.
	SharedSecret := MACompatibility
		request: 'SlideShare Shared Secret:'
		default: ''! !

!PRSlideShareLink class methodsFor: 'testing' stamp: 'lr 9/8/2008 16:56'!
isValidReference: aString
	^ aString beginsWith: 'slideshare:'! !

!PRSlideShareLink class methodsFor: 'accessing' stamp: 'lr 9/8/2008 16:55'!
priority
	^ 20! !

!PRSlideShareLink methodsFor: 'visiting' stamp: 'lr 9/8/2008 21:31'!
accept: aVisitor
	aVisitor visitSlideSlideLink: self! !

!PRSlideShareLink methodsFor: 'private' stamp: 'lr 9/8/2008 21:44'!
fetch: aString
	| ts hash url response result |
	ts := Time totalSeconds asString.
	hash := ((SecureHashAlgorithm new
		hashMessage: SharedSecret , ts)
		printStringBase: 16)
		asLowercase.
	url := 'http://www.slideshare.net/api/1/get_slideshow_info?api_key=' , 
		ApiKey , '&ts=' , ts , '&hash=' , hash , '&slideshow_id=' , aString.
	response := HTTPSocket httpGet: url.
	result := Dictionary new.
	result isString ifFalse: [
		(XMLDOMParser parseDocumentFrom: response)
			tagsNamed: #Slideshow do: [ :element |
				element elementsDo: [ :each |
					result at: each localName put: each contentString ] ] ].
	^ result! !

!PRSlideShareLink methodsFor: 'accessing-parameters' stamp: 'lr 9/8/2008 21:56'!
height
	^ self parameterAt: 'height' ifAbsent: [ (self width / 1.1972) rounded ]! !

!PRSlideShareLink methodsFor: 'accessing-dynamic' stamp: 'lr 9/8/2008 21:38'!
id
	^ data at: #PlayerDoc ifAbsent: [ String new ]! !

!PRSlideShareLink methodsFor: 'testing' stamp: 'lr 9/8/2008 21:28'!
isBroken
	^ data isEmpty! !

!PRSlideShareLink methodsFor: 'accessing' stamp: 'lr 9/8/2008 21:45'!
reference: aString
	super reference: aString.
	data := self fetch: self urlEntry! !

!PRSlideShareLink methodsFor: 'accessing-dynamic' stamp: 'lr 9/8/2008 21:26'!
title
	^ data at: #Title ifAbsent: [ super title ]! !

!PRSlideShareLink methodsFor: 'accessing-dynamic' stamp: 'lr 9/8/2008 21:29'!
url
	^ data at: #URL ifAbsent: [ super url ]! !

!PRSlideShareLink methodsFor: 'accessing-dynamic' stamp: 'lr 9/8/2008 16:55'!
urlEntry
	^ super urlEntry copyAfter: $:! !

!PRSlideShareLink methodsFor: 'accessing-dynamic' stamp: 'lr 9/8/2008 21:30'!
urlPrefix
	^ '#'! !

!PRSlideShareLink methodsFor: 'accessing-parameters' stamp: 'lr 9/8/2008 17:06'!
width
	^ self parameterAt: 'width' ifAbsent: [ 425 ]! !

PRExternalLink subclass: #PRVimeoLink
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Media'!

!PRVimeoLink class methodsFor: 'testing' stamp: 'lr 9/29/2008 07:45'!
isValidReference: aString
	^ aString beginsWith: 'vimeo:'! !

!PRVimeoLink class methodsFor: 'accessing' stamp: 'lr 9/29/2008 07:40'!
priority
	^ 20! !

!PRVimeoLink methodsFor: 'visiting' stamp: 'lr 9/29/2008 07:51'!
accept: aVisitor
	aVisitor visitVimeoLink: self! !

!PRVimeoLink methodsFor: 'accessing-parameters' stamp: 'lr 9/29/2008 07:47'!
height
	^ self parameterAt: 'height' ifAbsent: [ 225 ]! !

!PRVimeoLink methodsFor: 'accessing-dynamic' stamp: 'lr 9/29/2008 07:40'!
urlEntry
	^ super urlEntry copyAfter: $:! !

!PRVimeoLink methodsFor: 'accessing-dynamic' stamp: 'lr 9/29/2008 07:46'!
urlPrefix
	^ 'http://vimeo.com/'! !

!PRVimeoLink methodsFor: 'accessing-parameters' stamp: 'lr 9/29/2008 07:46'!
width
	^ self parameterAt: 'width' ifAbsent: [ 400 ]! !

PRExternalLink subclass: #PRYouTubeLink
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Media'!

!PRYouTubeLink class methodsFor: 'testing' stamp: 'lr 9/29/2008 07:31'!
isValidReference: aString
	^ aString beginsWith: 'youtube:'! !

!PRYouTubeLink class methodsFor: 'accessing' stamp: 'lr 9/29/2008 07:30'!
priority
	^ 20! !

!PRYouTubeLink methodsFor: 'visiting' stamp: 'lr 9/29/2008 07:31'!
accept: aVisitor
	aVisitor visitYouTubeLink: self! !

!PRYouTubeLink methodsFor: 'accessing-parameters' stamp: 'lr 9/29/2008 07:32'!
height
	^ self parameterAt: 'height' ifAbsent: [ 344 ]! !

!PRYouTubeLink methodsFor: 'accessing-dynamic' stamp: 'lr 9/29/2008 07:30'!
urlEntry
	^ super urlEntry copyAfter: $:! !

!PRYouTubeLink methodsFor: 'accessing-dynamic' stamp: 'lr 9/29/2008 07:36'!
urlPrefix
	^ 'http://www.youtube.com/watch?v='! !

!PRYouTubeLink methodsFor: 'accessing-parameters' stamp: 'lr 9/29/2008 07:32'!
width
	^ self parameterAt: 'width' ifAbsent: [ 425 ]! !

!PRVisitor methodsFor: '*pier-media' stamp: 'lr 9/8/2008 21:31'!
visitSlideSlideLink: anObject
	self visitExternalLink: anObject! !

!PRVisitor methodsFor: '*pier-media' stamp: 'lr 9/29/2008 07:51'!
visitVimeoLink: anObject 
	self visitExternalLink: anObject! !

!PRVisitor methodsFor: '*pier-media' stamp: 'lr 9/29/2008 07:51'!
visitYouTubeLink: anObject 
	self visitExternalLink: anObject! !

!PRViewRenderer methodsFor: '*pier-media' stamp: 'lr 9/8/2008 21:53'!
visitSlideSlideLink: anObject
	(anObject isBroken not and: [ anObject isEmbedded ])
		ifTrue: [ html html: '<object style="margin: 0px" width="' , anObject width asString , '" height="' , anObject height asString , '"><param name="movie" value="http://static.slideshare.net/swf/ssplayer2.swf?doc=' , anObject id , '&rel=0"/><param name="allowFullScreen" value="true"/><param name="allowScriptAccess" value="always"/><embed src="http://static.slideshare.net/swf/ssplayer2.swf?doc=' , anObject id , '&rel=0" type="application/x-shockwave-flash" allowscriptaccess="always" allowfullscreen="true" width="' , anObject width asString , '" height="' , anObject height asString , '"></embed></object>' ]
		ifFalse: [
			html anchor
				class: 'external';
				url: anObject url;
				class: 'broken' if: anObject isBroken;
				with: [ self visitLink: anObject ] ]! !

!PRViewRenderer methodsFor: '*pier-media' stamp: 'lr 9/29/2008 07:51'!
visitVimeoLink: anObject 
	(anObject isBroken not and: [ anObject isEmbedded ]) 
		ifTrue: 
			[ html html: '<object width="' , anObject width asString , '" height="' , anObject height asString , '"><param name="allowfullscreen" value="true" /><param name="allowscriptaccess" value="always" /><param name="movie" value="http://vimeo.com/moogaloop.swf?clip_id=' , anObject urlEntry , '&amp;server=vimeo.com&amp;show_title=1&amp;show_byline=1&amp;show_portrait=0&amp;color=&amp;fullscreen=1" /><embed src="http://vimeo.com/moogaloop.swf?clip_id=' , anObject urlEntry , '&amp;server=vimeo.com&amp;show_title=1&amp;show_byline=1&amp;show_portrait=0&amp;color=&amp;fullscreen=1" type="application/x-shockwave-flash" allowfullscreen="true" allowscriptaccess="always" width="' , anObject width asString , '" height="' , anObject height asString , '"></embed></object>' ]
		ifFalse: 
			[ html anchor
				class: 'external';
				url: anObject url;
				with: [ self visitLink: anObject ] ]! !

!PRViewRenderer methodsFor: '*pier-media' stamp: 'lr 9/29/2008 07:51'!
visitYouTubeLink: anObject 
	(anObject isBroken not and: [ anObject isEmbedded ]) 
		ifTrue: 
			[ html html: '<object width="' , anObject width asString , '" height="' , anObject height asString , '"><param name="movie" value="http://www.youtube.com/v/' , anObject urlEntry , '"></param><param name="allowFullScreen" value="true"></param><embed src="http://www.youtube.com/v/' , anObject urlEntry , '" type="application/x-shockwave-flash" allowfullscreen="true" width="' , anObject width asString , '" height="' , anObject height asString , '"></embed></object>' ]
		ifFalse: 
			[ html anchor
				class: 'external';
				url: anObject url;
				with: [ self visitLink: anObject ] ]! !
PRSlideShareLink initialize!
